library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.user_pkg.all;

entity pipeline_h101 is
  port(
    dt_clk : in  std_logic;
    reset  : in  std_logic;
    addr   : in  std_logic_vector(31 downto 0);
    en     : in  std_logic;
    wen    : in  std_logic;
    din    : in  std_logic_vector(31 downto 0);
    dout   : out std_logic_vector(31 downto 0)
    );
end pipeline_h101;

architecture STR of pipeline_h101 is
begin

  -- TODO: instantiate glue logic, address generators, controller, and datapath


  




  -- Input RAM (make sure to declare signals for the following connections)  
  U_MEM_IN : entity work.dual_port_ram(SYNC_READ)
    generic map (
      data_width => C_MEM_IN_WIDTH,
      addr_width => C_ADDR_WIDTH)
    port map (
      clk        => dt_clk,
      wen        => mem_in_wen,         -- connect to glue logic
      waddr      => mem_in_waddr,       -- connect to glue logic
      wdata      => mem_in_wdata,       -- connect to glue logic
      raddr      => mem_in_raddr,
      rdata      => mem_in_rdata);

  -- Output RAM (make sure to declare signals for the following connections)
  U_MEM_OUT : entity work.dual_port_ram(SYNC_READ)
    generic map (
      data_width => C_MEM_OUT_WIDTH,
      addr_width => C_ADDR_WIDTH)
    port map (
      clk        => dt_clk,
      wen        => mem_out_wen,
      waddr      => mem_out_waddr,
      wdata      => mem_out_wdata,
      raddr      => mem_out_raddr,      -- connect to glue logic
      rdata      => mem_out_rdata       -- connect to glue logic
      );

end STR;
